#!/usr/bin/env python3

# SPDX-FileCopyrightText: 2025 Ilya Egorov <0x42005e1f@gmail.com>
# SPDX-License-Identifier: ISC

from contextvars import ContextVar
from threading import local
from typing import Final

class GreenLibraryNotFoundError(RuntimeError): ...

class NamedLocal(local):
    name: str | None = None

current_green_library_tlocal: Final[NamedLocal]

def threading_running() -> bool: ...
def eventlet_running() -> bool: ...
def gevent_running() -> bool: ...
def current_green_library(*, failsafe: bool = False) -> str: ...

class AsyncLibraryNotFoundError(RuntimeError): ...

current_async_library_tlocal: Final[NamedLocal]
current_async_library_cvar: Final[ContextVar[str | None]]

def asyncio_running() -> bool: ...
def curio_running() -> bool: ...
def trio_running() -> bool: ...
def current_async_library(*, failsafe: bool = False) -> str: ...
